import java.io.*;
import java.util.*;

/*
 Sia ${\tt c_{n}x^{n}+...+c_{0}}$, con ${\tt n\!\geq\!0, c_{n}\neq\!0, (i\in[0,n])\,c_{i}\!\in\![int
 polinomio (a coefficienti interi) di grado n.
 Si definisca in Java un tipo astratto per polinomi (a struttura e valore dei componenti) MODIFICABILI.
 In particolare:
 (a) Si definisca lo stato concreto;
 (b) Le funzioni AF ed I;
 (c) Si definiscano i costruttori;
 (d) Si definisca 1 operazione osservatore e, 1 operazione modificatore.
 (e) Si fornisca un caso di uso
*/

/* (a) */
class invalidArgException extends Exception{
}

public class PolyJADT{
    private int grado;
    private Vector<Integer> coeff;
    
    public PolyJADT(int n) throws invalidArgException{
        if(n<0) throw new invalidArgException();
        grado = 0;
        coeff = new Vector<Integer>();
        coeff.add(n);
    }
    public int getCoeff(int grd) throws invalidArgException{
        if(grd<0 || grd>grado) throw new invalidArgException();
        return coeff.get(grd);
    }
    public void addMono(int grd, int cff) throws invalidArgException{
        if(grd<0) throw new invalidArgException();
        if(grd<=grado) {
            coeff.set(grd,coeff.get(grd)+cff);
            return;
        }
        for(int i=grd+1;i<grado;i++){
            coeff.add(i,0);
        }
        coeff.add(grd,cff);
        grado = grd;
    }
}

/* b
AF(c) = c_{n}x^{n}+...+c_{0}, dove n=c.grado && (i\in[0..n])c_{i}=c.coeff.get(i)
I(c) = c.coeff!=null && c.grado>=0 && c.coeff.size()==c.grado+1 && c.coeff.get(c.grado)!=0
 */

/* c */
class main{
    public static void main(String args[])throws invalidArgException{
    PolyJADT p = new PolyJADT(12);
        p.addMono(8,-5);
        //il polinomio -5 x^{8} + 12
    }
}

