import java.lang.*;
import java.io.*;

/*
date: 4/5/2016
Si consideri la definizione di coppia in Pair.Java, per coppie non modificabili. 
Si chiede di:
 (a) Ridefinirla in un un ADT, ImPairADTX.java, per coppie non modificabili e
     equipaggiata degli additionals (equals,clone,toString,elements) necessari;
 (b) Fornire AF e I  di (della rappresentazione data in) PairADT.java;
 (c) Fornire un caso di uso di PairADT.java;
 (d) Provare la correttezza di I.

 public class Pair <A,B> {
   public final A left;
   public final B right;
   public Pair (A x, B y) {
      left = x;
      right = y;
   }
}
 */

/* (a) */
class ImPairADTX<A,B> implements Cloneable{
    private final A left;//da nascondere
    private final B right;//da nascondere
    public ImPairADTX (A x, B y) {
        left = x;
        right = y;
    }
    public A getLeft(){//da aggiungere per uso effettivo
        return left;
    }
    public B getRight(){//da aggiungere per uso effettivo
        return right;
    }
    public boolean equals(Object o){//override equals
        ImPairADTX<?,?> ok;
        try{ok = (ImPairADTX<?,?>)o;}
        catch(Exception e){return false;}
        return (left.equals(ok.left) && right.equals(ok.right));
    }
    public ImPairADTX<A,B> clone() throws CloneNotSupportedException{
         return ((ImPairADTX<A,B>) super.clone());
    }
    public String toString(){
        return ("("+left.toString()+","+right.toString()+")");
    }
}

/* (b) 
Sia [ImPairADT<Ta,Tb>]={(x,y) | x\inTa, y\inTb, Ta\in[A], Tb\in[B]}, l'insieme dei valori
astratti definiti da ImPairADT<Ta,Tb>. Allora, per ogni valore concreto c esprimibile con
lo stato concreto definito dai fields della classe:
AF(c) = (c.left,c.right)
I(c) = true
*/

/* (c)  */
class main{
    public static void main(String args[])throws CloneNotSupportedException{
        ImPairADTX <Integer,String> myPlayCard = new ImPairADTX<Integer,String>(3,"fiori");
        System.out.println("il valore della carta è " + myPlayCard.getLeft());
        ImPairADTX <Integer,String> myPlayCard2 = new ImPairADTX<Integer,String>(3,"fiori");
        System.out.println("myPlayCard e myPlayCard2 sono tra loro scambiabili? " + myPlayCard.equals(myPlayCard2));
        ImPairADTX <Integer,String> myPlayCard3 = myPlayCard.clone();
        System.out.println("myPlayCard e un suo clone sono tra loro scambiali? " + myPlayCard.equals(myPlayCard3));
        System.out.println("una presentazione della carta è " + myPlayCard.toString());
    }
}

/* (d) 
I(c) è true quindi è sempre verificato quindi la correttezza è banalmente provata
*/
